using System;

namespace Plux {
  [SlotDefinition("Plux.Action")]
  [Param("MenuItem", typeof(string), "")]
  [Param("LazyLoad", typeof(bool), true)]
  [Param("Tag", typeof(string), "")]
  [Param("Description", typeof(string), "")]
  public interface IAction {
    void Do(object sender, ActionEventArgs args);
    bool IsEnabled(object sender, ActionEventArgs args);
  }

  public class ActionEventArgs : EventArgs {
    public PlugInfo Plug { get; private set; }
    public SlotInfo SlotInfo { get; private set; }
    public ActionEventArgs(PlugInfo plug, SlotInfo slot) {
      Plug = plug;
      SlotInfo = slot;
    }
    public ActionEventArgs(PlugEventArgs args) {
      Plug = args.PlugInfo;
      SlotInfo = args.SlotInfo;
    }
  }
}